Index: /trunk/src/VBox/Devices/Network/DevPCNet.cpp
===================================================================
--- /trunk/src/VBox/Devices/Network/DevPCNet.cpp	(revision 2936)
+++ /trunk/src/VBox/Devices/Network/DevPCNet.cpp	(revision 2937)
@@ -539,5 +539,5 @@
 *******************************************************************************/
 #define PRINT_TMD(T) Log2((    \
-        "TMD0 : TBADR=0x%08x\n" \
+        "TMD0 : TBADR=%#010x\n" \
         "TMD1 : OWN=%d, ERR=%d, FCS=%d, LTI=%d, "       \
         "ONE=%d, DEF=%d, STP=%d, ENP=%d,\n"             \
@@ -556,5 +556,5 @@
 
 #define PRINT_RMD(R) Log2((    \
-        "RMD0 : RBADR=0x%08x\n" \
+        "RMD0 : RBADR=%#010x\n" \
         "RMD1 : OWN=%d, ERR=%d, FRAM=%d, OFLO=%d, "     \
         "CRC=%d, BUFF=%d, STP=%d, ENP=%d,\n       "     \
@@ -785,5 +785,5 @@
     Log(("packet dhost=%02x:%02x:%02x:%02x:%02x:%02x, "               \
          "shost=%02x:%02x:%02x:%02x:%02x:%02x, "                      \
-         "type=0x%04x (bcast=%d)\n",                                  \
+         "type=%#06x (bcast=%d)\n",                                  \
          hdr->ether_dhost[0],hdr->ether_dhost[1],hdr->ether_dhost[2], \
          hdr->ether_dhost[3],hdr->ether_dhost[4],hdr->ether_dhost[5], \
@@ -1026,5 +1026,5 @@
     PCNetState *pData   = (PCNetState *)pvUser;
 
-    Log(("#%d pcnetHandleRingWriteGC: write to %08x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, GCPhysFault));
+    Log(("#%d pcnetHandleRingWriteGC: write to %#010x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, GCPhysFault));
 
     uint32_t cb;
@@ -1087,5 +1087,5 @@
     PCNetState *pData   = PDMINS2DATA(pDevIns, PCNetState *);
 
-    Log(("#%d pcnetHandleRingWrite: write to %08x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, GCPhys));
+    Log(("#%d pcnetHandleRingWrite: write to %#010x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, GCPhys));
 #ifdef VBOX_WITH_STATISTICS
     STAM_COUNTER_INC(&CTXSUFF(pData->StatRingWrite));
@@ -1257,6 +1257,6 @@
     int rc;
 
-    Log(("pcnetUpdateRingHandlers TD %VGp size %x -> %VGp size %x\n", pData->TDRAPhysOld, pData->cbTDRAOld, pData->GCTDRA, pcnetTdraAddr(pData, 0)));
-    Log(("pcnetUpdateRingHandlers RX %VGp size %x -> %VGp size %x\n", pData->RDRAPhysOld, pData->cbRDRAOld, pData->GCRDRA, pcnetRdraAddr(pData, 0)));
+    Log(("pcnetUpdateRingHandlers TD %VGp size %#x -> %VGp size %#x\n", pData->TDRAPhysOld, pData->cbTDRAOld, pData->GCTDRA, pcnetTdraAddr(pData, 0)));
+    Log(("pcnetUpdateRingHandlers RX %VGp size %#x -> %VGp size %#x\n", pData->RDRAPhysOld, pData->cbRDRAOld, pData->GCRDRA, pcnetRdraAddr(pData, 0)));
 
     /** @todo unregister order not correct! */
@@ -1343,5 +1343,5 @@
 {
     PPDMDEVINS pDevIns = PCNETSTATE_2_DEVINS(pData);
-    Log(("#%d pcnetInit: init_addr=0x%08x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log(("#%d pcnetInit: init_addr=%#010x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          PHYSADDR(pData, CSR_IADR(pData))));
 
@@ -1371,5 +1371,5 @@
         pData->GCUpperPhys = 0;
         PCNET_INIT();
-        Log(("#%d initblk.rlen=0x%02x, initblk.tlen=0x%02x\n",
+        Log(("#%d initblk.rlen=%#04x, initblk.tlen=%#04x\n",
              PCNETSTATE_2_DEVINS(pData)->iInstance, initblk.rlen, initblk.tlen));
     }
@@ -1379,5 +1379,5 @@
         pData->GCUpperPhys = (0xff00 & (uint32_t)pData->aCSR[2]) << 16;
         PCNET_INIT();
-        Log(("#%d initblk.rlen=0x%02x, initblk.tlen=0x%02x\n",
+        Log(("#%d initblk.rlen=%#04x, initblk.tlen=%#04x\n",
              PCNETSTATE_2_DEVINS(pData)->iInstance, initblk.rlen, initblk.tlen));
     }
@@ -1399,5 +1399,5 @@
     CSR_CXST(pData) = CSR_CXBC(pData) = CSR_NXST(pData) = CSR_NXBC(pData) = 0;
 
-    LogRel(("PCNet#%d: Init: ss32=%d GCRDRA=0x%08x[%d] GCTDRA=0x%08x[%d]\n",
+    LogRel(("PCNet#%d: Init: ss32=%d GCRDRA=%#010x[%d] GCTDRA=%#010x[%d]\n",
             PCNETSTATE_2_DEVINS(pData)->iInstance, BCR_SSIZE32(pData),
             pData->GCRDRA, CSR_RCVRL(pData), pData->GCTDRA, CSR_XMTRL(pData)));
@@ -1498,5 +1498,5 @@
                 STAM_PROFILE_ADV_STOP(&pData->CTXSUFF(StatRdtePoll), a);
                 /* This is not problematic since we don't own the descriptor */
-                LogRel(("PCNet#%d: BAD RMD ENTRIES AT 0x%08x (i=%d)\n",
+                LogRel(("PCNet#%d: BAD RMD ENTRIES AT %#010x (i=%d)\n",
                         PCNETSTATE_2_DEVINS(pData)->iInstance, addr, i));
                 return;
@@ -1529,5 +1529,5 @@
             STAM_PROFILE_ADV_STOP(&pData->CTXSUFF(StatRdtePoll), a);
             /* This is not problematic since we don't own the descriptor */
-            LogRel(("PCNet#%d: BAD RMD ENTRIES + AT 0x%08x (i=%d)\n",
+            LogRel(("PCNet#%d: BAD RMD ENTRIES + AT %#010x (i=%d)\n",
                     PCNETSTATE_2_DEVINS(pData)->iInstance, addr, i));
             return;
@@ -1568,5 +1568,5 @@
         {
             STAM_PROFILE_ADV_STOP(&pData->CTXSUFF(StatTdtePoll), a);
-            LogRel(("PCNet#%d: BAD TMD XDA=0x%08x\n",
+            LogRel(("PCNet#%d: BAD TMD XDA=%#010x\n",
                     PCNETSTATE_2_DEVINS(pData)->iInstance, PHYSADDR(pData, cxda)));
             return 0;
@@ -1663,5 +1663,5 @@
                 RMD rmd;
                 pcnetRmdLoad(pData, &rmd, PHYSADDR(pData, GCPhys));
-                LogRel(("  %08x\n", rmd.rmd1));
+                LogRel(("  %#010x\n", rmd.rmd1));
                 GCPhys += cb;
             }
@@ -1761,5 +1761,5 @@
             pData->aCSR[0] |= 0x0400;
 
-            Log(("#%d RCVRC=%d CRDA=0x%08x BLKS=%d\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+            Log(("#%d RCVRC=%d CRDA=%#010x BLKS=%d\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
                  CSR_RCVRC(pData), PHYSADDR(pData, CSR_CRDA(pData)), pktcount));
 #ifdef PCNET_DEBUG_RMD
@@ -2023,5 +2023,5 @@
 
 #ifdef PCNET_DEBUG_TMD
-        Log2(("#%d TMDLOAD 0x%08x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, PHYSADDR(pData, CSR_CXDA(pData))));
+        Log2(("#%d TMDLOAD %#010x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, PHYSADDR(pData, CSR_CXDA(pData))));
         PRINT_TMD(&tmd);
 #endif
@@ -2281,8 +2281,8 @@
 #ifdef LOG_ENABLED
     TMD dummy;
-    Log2(("#%d pcnetPollTimer time=%08x TDMD=%d TXON=%d POLL=%d TDTE=%d TDRA=%x\n",
+    Log2(("#%d pcnetPollTimer time=%#010x TDMD=%d TXON=%d POLL=%d TDTE=%d TDRA=%#x\n",
           PCNETSTATE_2_DEVINS(pData)->iInstance, RTTimeMilliTS(), CSR_TDMD(pData), CSR_TXON(pData),
           !CSR_DPOLL(pData), pcnetTdtePoll(pData, &dummy), pData->GCTDRA));
-    Log2(("#%d pcnetPollTimer: CSR_CXDA=%x CSR_XMTRL=%d CSR_XMTRC=%d\n",
+    Log2(("#%d pcnetPollTimer: CSR_CXDA=%#x CSR_XMTRL=%d CSR_XMTRC=%d\n",
           PCNETSTATE_2_DEVINS(pData)->iInstance, CSR_CXDA(pData), CSR_XMTRL(pData), CSR_XMTRC(pData)));
 #endif
@@ -2292,5 +2292,5 @@
         TMD tmd;
         pcnetTmdLoad(pData, &tmd, PHYSADDR(pData, CSR_CXDA(pData)));
-        Log2(("#%d pcnetPollTimer: TMDLOAD 0x%08x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, PHYSADDR(pData, CSR_CXDA(pData))));
+        Log2(("#%d pcnetPollTimer: TMDLOAD %#010x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, PHYSADDR(pData, CSR_CXDA(pData))));
         PRINT_TMD(&tmd);
     }
@@ -2333,5 +2333,5 @@
     int      rc  = VINF_SUCCESS;
 #ifdef PCNET_DEBUG_CSR
-    Log(("#%d pcnetCSRWriteU16: rap=%d val=0x%04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, u32RAP, val));
+    Log(("#%d pcnetCSRWriteU16: rap=%d val=%#06x\n", PCNETSTATE_2_DEVINS(pData)->iInstance, u32RAP, val));
 #endif
     switch (u32RAP)
@@ -2357,5 +2357,5 @@
                 }
 #endif
-                LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %04x => %04x (%04x)\n",
+                LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %#06x => %#06x (%#06x)\n",
                               PCNETSTATE_2_DEVINS(pData)->iInstance,
                               u32RAP, new_value, csr0, pData->aCSR[0]));
@@ -2426,13 +2426,13 @@
             if (CSR_STOP(pData) || CSR_SPND(pData))
                 break;
-            LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %04x\n",
+            LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %#06x\n",
                          PCNETSTATE_2_DEVINS(pData)->iInstance, u32RAP, val));
             return rc;
         case 3: /* Interrupt Mask and Deferral Control */
-            LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %04x\n",
+            LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %#06x\n",
                          PCNETSTATE_2_DEVINS(pData)->iInstance, u32RAP, val));
             break;
         case 4: /* Test and Features Control */
-            LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %04x\n",
+            LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %#06x\n",
                          PCNETSTATE_2_DEVINS(pData)->iInstance, u32RAP, val));
             pData->aCSR[4] &= ~(val & 0x026a);
@@ -2441,5 +2441,5 @@
             break;
         case 5: /* Extended Control and Interrupt 1 */
-            LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %04x\n",
+            LOG_REGISTER(("PCNet#%d: WRITE CSR%d, %#06x\n",
                         PCNETSTATE_2_DEVINS(pData)->iInstance, u32RAP, val));
             pData->aCSR[5] &= ~(val & 0x0a90);
@@ -2465,5 +2465,5 @@
             return pcnetCSRWriteU16(pData, 2, val);
         case 58: /* Software Style */
-            LOG_REGISTER(("PCNet#%d: WRITE SW_STYLE, %04x\n",
+            LOG_REGISTER(("PCNet#%d: WRITE SW_STYLE, %#06x\n",
                          PCNETSTATE_2_DEVINS(pData)->iInstance, val));
             rc = pcnetBCRWriteU16(pData, BCR_SWS, val);
@@ -2500,9 +2500,9 @@
         default:
             val = pData->aCSR[u32RAP];
-            LOG_REGISTER(("PCNet#%d: read  CSR%d => %04x\n",
+            LOG_REGISTER(("PCNet#%d: read  CSR%d => %#06x\n",
                     PCNETSTATE_2_DEVINS(pData)->iInstance, u32RAP, val));
     }
 #ifdef PCNET_DEBUG_CSR
-    Log(("#%d pcnetCSRReadU16: u32RAP=%d val=0x%04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log(("#%d pcnetCSRReadU16: u32RAP=%d val=%#06x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          u32RAP, val));
 #endif
@@ -2515,5 +2515,5 @@
     u32RAP &= 0x7f;
 #ifdef PCNET_DEBUG_BCR
-    Log2(("#%d pcnetBCRWriteU16: u32RAP=%d val=0x%04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetBCRWriteU16: u32RAP=%d val=%#06x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          u32RAP, val));
 #endif
@@ -2527,5 +2527,5 @@
             {
                 default:
-                    Log(("Bad SWSTYLE=0x%02x\n", val & 0xff));
+                    Log(("Bad SWSTYLE=%#04x\n", val & 0xff));
                     // fall through
                 case 0:
@@ -2546,7 +2546,7 @@
                     break;
             }
-            LOG_REGISTER(("PCNet#%d: WRITE SW_STYLE, %04x\n",
+            LOG_REGISTER(("PCNet#%d: WRITE SW_STYLE, %#06x\n",
                          PCNETSTATE_2_DEVINS(pData)->iInstance, val));
-            Log(("BCR_SWS=0x%04x\n", val));
+            Log(("BCR_SWS=%#06x\n", val));
             pData->aCSR[58] = val;
             /* fall through */
@@ -2561,5 +2561,5 @@
         case BCR_PLAT:
         case BCR_MIIADDR:
-            LOG_REGISTER(("PCNet#%d: WRITE BCR%d, %04x\n",
+            LOG_REGISTER(("PCNet#%d: WRITE BCR%d, %#06x\n",
                          PCNETSTATE_2_DEVINS(pData)->iInstance, u32RAP, val));
             pData->aBCR[u32RAP] = val;
@@ -2567,5 +2567,5 @@
 
         case BCR_MIIMDR:
-            LOG_REGISTER(("PCNet#%d: WRITE MII%d, %04x\n",
+            LOG_REGISTER(("PCNet#%d: WRITE MII%d, %#06x\n",
                          PCNETSTATE_2_DEVINS(pData)->iInstance, u32RAP, val));
             pData->aMII[pData->aBCR[BCR_MIIADDR] & 0x1f] = val;
@@ -2698,5 +2698,5 @@
     }
 #ifdef PCNET_DEBUG_BCR
-    Log2(("#%d pcnetBCRReadU16: u32RAP=%d val=0x%04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetBCRReadU16: u32RAP=%d val=%#06x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          u32RAP, val));
 #endif
@@ -2743,5 +2743,5 @@
     addr &= 0x0f;
     val  &= 0xff;
-    Log(("#%d pcnetAPROMWriteU8: addr=0x%08x val=0x%02x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log(("#%d pcnetAPROMWriteU8: addr=%#010x val=%#04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val));
     /* Check APROMWE bit to enable write access */
@@ -2753,5 +2753,5 @@
 {
     uint32_t val = pData->aPROM[addr &= 0x0f];
-    Log(("#%d pcnetAPROMReadU8: addr=0x%08x val=0x%02x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log(("#%d pcnetAPROMReadU8: addr=%#010x val=%#04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val));
     return val;
@@ -2763,5 +2763,5 @@
 
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetIoportWriteU16: addr=0x%08x val=0x%04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetIoportWriteU16: addr=%#010x val=%#06x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val));
 #endif
@@ -2823,5 +2823,5 @@
 skip_update_irq:
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetIoportReadU16: addr=0x%08x val=0x%04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetIoportReadU16: addr=%#010x val=%#06x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val & 0xffff));
 #endif
@@ -2834,5 +2834,5 @@
 
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetIoportWriteU32: addr=0x%08x val=0x%08x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetIoportWriteU32: addr=%#010x val=%#010x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val));
 #endif
@@ -2902,5 +2902,5 @@
 skip_update_irq:
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetIoportReadU32: addr=0x%08x val=0x%08x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetIoportReadU32: addr=%#010x val=%#010x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val));
 #endif
@@ -2911,5 +2911,5 @@
 {
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetMMIOWriteU8: addr=0x%08x val=0x%02x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetMMIOWriteU8: addr=%#010x val=%#04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val));
 #endif
@@ -2924,5 +2924,5 @@
         val = pcnetAPROMReadU8(pData, addr);
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetMMIOReadU8: addr=0x%08x val=0x%02x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetMMIOReadU8: addr=%#010x val=%#04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val & 0xff));
 #endif
@@ -2933,5 +2933,5 @@
 {
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetMMIOWriteU16: addr=0x%08x val=0x%04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetMMIOWriteU16: addr=%#010x val=%#06x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val));
 #endif
@@ -2959,5 +2959,5 @@
     }
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetMMIOReadU16: addr=0x%08x val = 0x%04x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetMMIOReadU16: addr=%#010x val = %#06x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val & 0xffff));
 #endif
@@ -2968,5 +2968,5 @@
 {
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetMMIOWriteU32: addr=0x%08x val=0x%08x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetMMIOWriteU32: addr=%#010x val=%#010x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val));
 #endif
@@ -3000,5 +3000,5 @@
     }
 #ifdef PCNET_DEBUG_IO
-    Log2(("#%d pcnetMMIOReadU32: addr=0x%08x val=0x%08x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
+    Log2(("#%d pcnetMMIOReadU32: addr=%#010x val=%#010x\n", PCNETSTATE_2_DEVINS(pData)->iInstance,
          addr, val));
 #endif
@@ -3444,17 +3444,17 @@
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR0=%04RX32:\n",
+                    "CSR0=%#06x:\n",
                     pData->aCSR[0]);
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR1=%04RX32:\n",
+                    "CSR1=%#06x:\n",
                     pData->aCSR[1]);
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR2=%04RX32:\n",
+                    "CSR2=%#06x:\n",
                     pData->aCSR[2]);
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR3=%04RX32: BSWP=%d EMBA=%d DXMT2PD=%d LAPPEN=%d DXSUFLO=%d IDONM=%d TINTM=%d RINTM=%d MERRM=%d MISSM=%d BABLM=%d\n",
+                    "CSR3=%#06x: BSWP=%d EMBA=%d DXMT2PD=%d LAPPEN=%d DXSUFLO=%d IDONM=%d TINTM=%d RINTM=%d MERRM=%d MISSM=%d BABLM=%d\n",
                     pData->aCSR[3],
                     !!(pData->aCSR[3] & BIT(2)), !!(pData->aCSR[3] & BIT(3)), !!(pData->aCSR[3] & BIT(4)), CSR_LAPPEN(pData),
@@ -3463,6 +3463,6 @@
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR4=%04RX32: JABM=%d JAB=%d TXSTRM=%d TXSTRT=%d RCVCOOM=%d RCVCCO=%d UINT=%d UINTCMD=%d\n"
-                    "            MFCOM=%d MFCO=%d ASTRP_RCV=%d APAD_XMT=%d DPOLL=%d TIMER=%d EMAPLUS=%d EN124=%d\n",
+                    "CSR4=%#06x: JABM=%d JAB=%d TXSTRM=%d TXSTRT=%d RCVCOOM=%d RCVCCO=%d UINT=%d UINTCMD=%d\n"
+                    "              MFCOM=%d MFCO=%d ASTRP_RCV=%d APAD_XMT=%d DPOLL=%d TIMER=%d EMAPLUS=%d EN124=%d\n",
                     pData->aCSR[4],
                     !!(pData->aCSR[4] & BIT( 0)), !!(pData->aCSR[4] & BIT( 1)), !!(pData->aCSR[4] & BIT( 2)), !!(pData->aCSR[4] & BIT( 3)),
@@ -3472,14 +3472,14 @@
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR5=%04RX32:\n",
+                    "CSR5=%#06x:\n",
                     pData->aCSR[5]);
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR6=%04RX32: RLEN=%03x* TLEN=%03x* [* encoded]\n",
+                    "CSR6=%#06x: RLEN=%#x* TLEN=%#x* [* encoded]\n",
                     pData->aCSR[6],
                     (pData->aCSR[6] >> 8) & 0xf, (pData->aCSR[6] >> 12) & 0xf);
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR8..11=%04RX32,%04RX32,%04RX32,%04RX32: LADRF=%016RX64\n",
+                    "CSR8..11=%#06x,%#06x,%#06x,%#06x: LADRF=%#018llx\n",
                     pData->aCSR[8], pData->aCSR[9], pData->aCSR[10], pData->aCSR[11],
                       (uint64_t)(pData->aCSR[ 8] & 0xffff)
@@ -3489,5 +3489,5 @@
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR12..14=%04RX32,%04RX32,%04RX32: PADR=%02x %02x %02x %02x %02x %02x (Current MAC Address)\n",
+                    "CSR12..14=%#06x,%#06x,%#06x: PADR=%02x:%02x:%02x:%02x:%02x:%02x (Current MAC Address)\n",
                     pData->aCSR[12], pData->aCSR[13], pData->aCSR[14],
                      pData->aCSR[12]       & 0xff,
@@ -3499,6 +3499,6 @@
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR15=%04RX32: DXR=%d DTX=%d LOOP=%d DXMTFCS=%d FCOLL=%d DRTY=%d INTL=%d PORTSEL=%d LTR=%d\n"
-                    "            MENDECL=%d DAPC=%d DLNKTST=%d DRCVPV=%d DRCVBC=%d PROM=%d\n",
+                    "CSR15=%#06x: DXR=%d DTX=%d LOOP=%d DXMTFCS=%d FCOLL=%d DRTY=%d INTL=%d PORTSEL=%d LTR=%d\n"
+                    "              MENDECL=%d DAPC=%d DLNKTST=%d DRCVPV=%d DRCVBC=%d PROM=%d\n",
                     pData->aCSR[15],
                     !!(pData->aCSR[15] & BIT( 0)), !!(pData->aCSR[15] & BIT( 1)), !!(pData->aCSR[15] & BIT( 2)), !!(pData->aCSR[15] & BIT( 3)),
@@ -3508,13 +3508,13 @@
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR46=%04RX32: POLL=%04x (Poll Time Counter)\n",
+                    "CSR46=%#06x: POLL=%#06x (Poll Time Counter)\n",
                     pData->aCSR[46], pData->aCSR[46] & 0xffff);
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR47=%04RX32: POLLINT=%04x (Poll Time Interval)\n",
+                    "CSR47=%#06x: POLLINT=%#06x (Poll Time Interval)\n",
                     pData->aCSR[47], pData->aCSR[47] & 0xffff);
 
     pHlp->pfnPrintf(pHlp,
-                    "CSR58=%04RX32: SWSTYLE=%02x %s SSIZE32=%d CSRPCNET=%d APERRENT=%d\n",
+                    "CSR58=%#06x: SWSTYLE=%d %s SSIZE32=%d CSRPCNET=%d APERRENT=%d\n",
                     pData->aCSR[58],
                     pData->aCSR[58] & 0x7f,
@@ -3564,5 +3564,5 @@
                             "%04x %RGp:%c%c RBADR=%08RX32 BCNT=%03x MCNT=%03x "
                             "OWN=%d ERR=%d FRAM=%d OFLO=%d CRC=%d BUFF=%d STP=%d ENP=%d BPE=%d "
-                            "PAM=%d LAFM=%d BAM=%d RCC=%02x RPC=%02x ONES=%x ZEROS=%d\n",
+                            "PAM=%d LAFM=%d BAM=%d RCC=%02x RPC=%02x ONES=%#x ZEROS=%d\n",
                             i, GCPhys, i + 1 == CSR_RCVRC(pData) ? '*' : ' ', GCPhys == CSR_CRDA(pData) ? '*' : ' ',
                             rmd.rmd0.rbadr, 4096 - rmd.rmd1.bcnt, rmd.rmd2.mcnt,
@@ -3604,5 +3604,5 @@
                             "%04x %RGp:%c%c TBADR=%08RX32 BCNT=%03x OWN=%d "
                             "ERR=%d NOFCS=%d LTINT=%d ONE=%d DEF=%d STP=%d ENP=%d BPE=%d "
-                            "BUFF=%d UFLO=%d EXDEF=%d LCOL=%d LCAR=%d RTRY=%d TDR=%03x TRC=%x ONES=%x\n"
+                            "BUFF=%d UFLO=%d EXDEF=%d LCOL=%d LCAR=%d RTRY=%d TDR=%03x TRC=%#x ONES=%#x\n"
                             ,
                             i, GCPhys, i + 1 == CSR_XMTRC(pData) ? '*' : ' ', GCPhys == CSR_CXDA(pData) ? '*' : ' ',