Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 2976)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 2979)
@@ -1102,5 +1102,5 @@
     vmShowLogsAction->setAccel (tr ("Ctrl+L"));
     vmShowLogsAction->setStatusTip (
-        tr ("Show the log of the selected virtual machine"));
+        tr ("Show the log files of the selected virtual machine"));
 
     helpContentsAction->setMenuText (tr ("&Contents..."));
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui	(revision 2976)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui	(revision 2979)
@@ -47,5 +47,5 @@
         </property>
         <property name="spacing">
-            <number>0</number>
+            <number>10</number>
         </property>
         <widget class="QGroupBox">
@@ -218,13 +218,134 @@
                     </property>
                 </widget>
-                <widget class="QGroupBox">
+            </vbox>
+        </widget>
+        <widget class="QGroupBox">
+            <property name="name">
+                <cstring>grbTAP</cstring>
+            </property>
+            <property name="title">
+                <string>Host Interface Settings</string>
+            </property>
+            <property name="flat">
+                <bool>false</bool>
+            </property>
+            <vbox>
+                <property name="name">
+                    <cstring>unnamed</cstring>
+                </property>
+                <widget class="QLayoutWidget">
                     <property name="name">
-                        <cstring>grbTAP</cstring>
-                    </property>
-                    <property name="title">
-                        <string>Host Interface Settings</string>
-                    </property>
-                    <property name="flat">
-                        <bool>false</bool>
+                        <cstring>layout120</cstring>
+                    </property>
+                    <hbox>
+                        <property name="name">
+                            <cstring>unnamed</cstring>
+                        </property>
+                        <widget class="QFrame">
+                            <property name="name">
+                                <cstring>frmHostInterface_X11</cstring>
+                            </property>
+                            <property name="frameShape">
+                                <enum>NoFrame</enum>
+                            </property>
+                            <property name="frameShadow">
+                                <enum>Raised</enum>
+                            </property>
+                            <vbox>
+                                <property name="name">
+                                    <cstring>unnamed</cstring>
+                                </property>
+                                <property name="margin">
+                                    <number>0</number>
+                                </property>
+                                <widget class="QLabel">
+                                    <property name="name">
+                                        <cstring>txHostInterface_X11</cstring>
+                                    </property>
+                                    <property name="sizePolicy">
+                                        <sizepolicy>
+                                            <hsizetype>0</hsizetype>
+                                            <vsizetype>5</vsizetype>
+                                            <horstretch>0</horstretch>
+                                            <verstretch>0</verstretch>
+                                        </sizepolicy>
+                                    </property>
+                                    <property name="text">
+                                        <string>&amp;Interface Name</string>
+                                    </property>
+                                    <property name="buddy" stdset="0">
+                                        <cstring>leHostInterface</cstring>
+                                    </property>
+                                </widget>
+                                <widget class="QLineEdit">
+                                    <property name="name">
+                                        <cstring>leHostInterface</cstring>
+                                    </property>
+                                    <property name="whatsThis" stdset="0">
+                                        <string>Displays the TAP interface name.</string>
+                                    </property>
+                                </widget>
+                            </vbox>
+                        </widget>
+                        <widget class="QFrame">
+                            <property name="name">
+                                <cstring>frmTAPDescriptor</cstring>
+                            </property>
+                            <property name="frameShape">
+                                <enum>NoFrame</enum>
+                            </property>
+                            <property name="frameShadow">
+                                <enum>Raised</enum>
+                            </property>
+                            <vbox>
+                                <property name="name">
+                                    <cstring>unnamed</cstring>
+                                </property>
+                                <property name="margin">
+                                    <number>0</number>
+                                </property>
+                                <widget class="QLabel">
+                                    <property name="name">
+                                        <cstring>txTAPDescriptor</cstring>
+                                    </property>
+                                    <property name="sizePolicy">
+                                        <sizepolicy>
+                                            <hsizetype>0</hsizetype>
+                                            <vsizetype>5</vsizetype>
+                                            <horstretch>0</horstretch>
+                                            <verstretch>0</verstretch>
+                                        </sizepolicy>
+                                    </property>
+                                    <property name="text">
+                                        <string>&amp;File Descriptor</string>
+                                    </property>
+                                    <property name="buddy" stdset="0">
+                                        <cstring>leTAPDescriptor</cstring>
+                                    </property>
+                                </widget>
+                                <widget class="QLineEdit">
+                                    <property name="name">
+                                        <cstring>leTAPDescriptor</cstring>
+                                    </property>
+                                    <property name="frameShape">
+                                        <enum>LineEditPanel</enum>
+                                    </property>
+                                    <property name="frameShadow">
+                                        <enum>Sunken</enum>
+                                    </property>
+                                </widget>
+                            </vbox>
+                        </widget>
+                    </hbox>
+                </widget>
+                <widget class="QFrame">
+                    <property name="name">
+                        <cstring>frmTAPSetupTerminate</cstring>
+                    </property>
+                    <property name="frameShape">
+                        <enum>NoFrame</enum>
+                    </property>
+                    <property name="frameShadow">
+                        <enum>Raised</enum>
                     </property>
                     <vbox>
@@ -232,118 +353,96 @@
                             <cstring>unnamed</cstring>
                         </property>
+                        <property name="margin">
+                            <number>0</number>
+                        </property>
                         <widget class="QLayoutWidget">
                             <property name="name">
-                                <cstring>layout120</cstring>
-                            </property>
-                            <hbox>
+                                <cstring>layout124</cstring>
+                            </property>
+                            <vbox>
                                 <property name="name">
                                     <cstring>unnamed</cstring>
                                 </property>
-                                <widget class="QFrame">
-                                    <property name="name">
-                                        <cstring>frmHostInterface_X11</cstring>
-                                    </property>
-                                    <property name="frameShape">
-                                        <enum>NoFrame</enum>
-                                    </property>
-                                    <property name="frameShadow">
-                                        <enum>Raised</enum>
-                                    </property>
-                                    <vbox>
+                                <property name="margin">
+                                    <number>0</number>
+                                </property>
+                                <property name="spacing">
+                                    <number>0</number>
+                                </property>
+                                <widget class="QLayoutWidget">
+                                    <property name="name">
+                                        <cstring>layout31</cstring>
+                                    </property>
+                                    <hbox>
                                         <property name="name">
                                             <cstring>unnamed</cstring>
                                         </property>
-                                        <property name="margin">
-                                            <number>0</number>
-                                        </property>
                                         <widget class="QLabel">
                                             <property name="name">
-                                                <cstring>txHostInterface_X11</cstring>
-                                            </property>
-                                            <property name="sizePolicy">
-                                                <sizepolicy>
-                                                    <hsizetype>0</hsizetype>
-                                                    <vsizetype>5</vsizetype>
-                                                    <horstretch>0</horstretch>
-                                                    <verstretch>0</verstretch>
-                                                </sizepolicy>
+                                                <cstring>txTAPSetup</cstring>
                                             </property>
                                             <property name="text">
-                                                <string>&amp;Interface Name</string>
+                                                <string>&amp;Setup Application</string>
                                             </property>
                                             <property name="buddy" stdset="0">
-                                                <cstring>leHostInterface</cstring>
+                                                <cstring>leTAPSetup</cstring>
                                             </property>
                                         </widget>
-                                        <widget class="QLineEdit">
-                                            <property name="name">
-                                                <cstring>leHostInterface</cstring>
-                                            </property>
-                                            <property name="whatsThis" stdset="0">
-                                                        <string>Displays the TAP interface name.</string>
-                                            </property>
-                                        </widget>
-                                    </vbox>
-                                </widget>
-                                <widget class="QFrame">
-                                    <property name="name">
-                                        <cstring>frmTAPDescriptor</cstring>
-                                    </property>
-                                    <property name="frameShape">
-                                        <enum>NoFrame</enum>
-                                    </property>
-                                    <property name="frameShadow">
-                                        <enum>Raised</enum>
-                                    </property>
-                                    <vbox>
+                                        <spacer>
+                                            <property name="name">
+                                                <cstring>spacer14</cstring>
+                                            </property>
+                                            <property name="orientation">
+                                                <enum>Horizontal</enum>
+                                            </property>
+                                            <property name="sizeType">
+                                                <enum>Expanding</enum>
+                                            </property>
+                                            <property name="sizeHint">
+                                                <size>
+                                                    <width>61</width>
+                                                    <height>20</height>
+                                                </size>
+                                            </property>
+                                        </spacer>
+                                    </hbox>
+                                </widget>
+                                <widget class="QLayoutWidget">
+                                    <property name="name">
+                                        <cstring>layout122</cstring>
+                                    </property>
+                                    <hbox>
                                         <property name="name">
                                             <cstring>unnamed</cstring>
                                         </property>
-                                        <property name="margin">
-                                            <number>0</number>
-                                        </property>
-                                        <widget class="QLabel">
-                                            <property name="name">
-                                                <cstring>txTAPDescriptor</cstring>
-                                            </property>
-                                            <property name="sizePolicy">
-                                                <sizepolicy>
-                                                    <hsizetype>0</hsizetype>
-                                                    <vsizetype>5</vsizetype>
-                                                    <horstretch>0</horstretch>
-                                                    <verstretch>0</verstretch>
-                                                </sizepolicy>
+                                        <widget class="QLineEdit">
+                                            <property name="name">
+                                                <cstring>leTAPSetup</cstring>
+                                            </property>
+                                            <property name="whatsThis" stdset="0">
+                                                <string>Displays the command executed to setup the TAP interface.</string>
+                                            </property>
+                                        </widget>
+                                        <widget class="QToolButton">
+                                            <property name="name">
+                                                <cstring>pbTAPSetup</cstring>
                                             </property>
                                             <property name="text">
-                                                <string>&amp;File Descriptor</string>
-                                            </property>
-                                            <property name="buddy" stdset="0">
-                                                <cstring>leTAPDescriptor</cstring>
+                                                <string>Select</string>
+                                            </property>
+                                            <property name="whatsThis" stdset="0">
+                                                <string>Selects the setup application.</string>
+                                            </property>
+                                            <property name="focusPolicy">
+                                                <enum>TabFocus</enum>
                                             </property>
                                         </widget>
-                                        <widget class="QLineEdit">
-                                            <property name="name">
-                                                <cstring>leTAPDescriptor</cstring>
-                                            </property>
-                                            <property name="frameShape">
-                                                <enum>LineEditPanel</enum>
-                                            </property>
-                                            <property name="frameShadow">
-                                                <enum>Sunken</enum>
-                                            </property>
-                                        </widget>
-                                    </vbox>
-                                </widget>
-                            </hbox>
-                        </widget>
-                        <widget class="QFrame">
-                            <property name="name">
-                                <cstring>frmTAPSetupTerminate</cstring>
-                            </property>
-                            <property name="frameShape">
-                                <enum>NoFrame</enum>
-                            </property>
-                            <property name="frameShadow">
-                                <enum>Raised</enum>
+                                    </hbox>
+                                </widget>
+                            </vbox>
+                        </widget>
+                        <widget class="QLayoutWidget">
+                            <property name="name">
+                                <cstring>layout125</cstring>
                             </property>
                             <vbox>
@@ -354,175 +453,82 @@
                                     <number>0</number>
                                 </property>
+                                <property name="spacing">
+                                    <number>0</number>
+                                </property>
                                 <widget class="QLayoutWidget">
                                     <property name="name">
-                                        <cstring>layout124</cstring>
-                                    </property>
-                                    <vbox>
+                                        <cstring>layout32</cstring>
+                                    </property>
+                                    <hbox>
                                         <property name="name">
                                             <cstring>unnamed</cstring>
                                         </property>
-                                        <property name="margin">
-                                            <number>0</number>
-                                        </property>
-                                        <property name="spacing">
-                                            <number>0</number>
-                                        </property>
-                                        <widget class="QLayoutWidget">
-                                            <property name="name">
-                                                <cstring>layout31</cstring>
-                                            </property>
-                                            <hbox>
-                                                <property name="name">
-                                                    <cstring>unnamed</cstring>
-                                                </property>
-                                                <widget class="QLabel">
-                                                    <property name="name">
-                                                        <cstring>txTAPSetup</cstring>
-                                                    </property>
-                                                    <property name="text">
-                                                        <string>&amp;Setup Application</string>
-                                                    </property>
-                                                    <property name="buddy" stdset="0">
-                                                        <cstring>leTAPSetup</cstring>
-                                                    </property>
-                                                </widget>
-                                                <spacer>
-                                                    <property name="name">
-                                                        <cstring>spacer14</cstring>
-                                                    </property>
-                                                    <property name="orientation">
-                                                        <enum>Horizontal</enum>
-                                                    </property>
-                                                    <property name="sizeType">
-                                                        <enum>Expanding</enum>
-                                                    </property>
-                                                    <property name="sizeHint">
-                                                        <size>
-                                                            <width>61</width>
-                                                            <height>20</height>
-                                                        </size>
-                                                    </property>
-                                                </spacer>
-                                            </hbox>
+                                        <widget class="QLabel">
+                                            <property name="name">
+                                                <cstring>txTAPTerminate</cstring>
+                                            </property>
+                                            <property name="text">
+                                                <string>&amp;Terminate Application</string>
+                                            </property>
+                                            <property name="buddy" stdset="0">
+                                                <cstring>leTAPTerminate</cstring>
+                                            </property>
                                         </widget>
-                                        <widget class="QLayoutWidget">
-                                            <property name="name">
-                                                <cstring>layout122</cstring>
-                                            </property>
-                                            <hbox>
-                                                <property name="name">
-                                                    <cstring>unnamed</cstring>
-                                                </property>
-                                                <widget class="QLineEdit">
-                                                    <property name="name">
-                                                        <cstring>leTAPSetup</cstring>
-                                                    </property>
-                                                    <property name="whatsThis" stdset="0">
-                                                        <string>Displays the command executed to setup the TAP interface.</string>
-                                                    </property>
-                                                </widget>
-                                                <widget class="QToolButton">
-                                                    <property name="name">
-                                                        <cstring>pbTAPSetup</cstring>
-                                                    </property>
-                                                    <property name="text">
-                                                        <string>Select</string>
-                                                    </property>
-                                                    <property name="whatsThis" stdset="0">
-                                                        <string>Selects the setup application.</string>
-                                                    </property>
-                                                </widget>
-                                            </hbox>
-                                        </widget>
-                                    </vbox>
+                                        <spacer>
+                                            <property name="name">
+                                                <cstring>spacer15</cstring>
+                                            </property>
+                                            <property name="orientation">
+                                                <enum>Horizontal</enum>
+                                            </property>
+                                            <property name="sizeType">
+                                                <enum>Expanding</enum>
+                                            </property>
+                                            <property name="sizeHint">
+                                                <size>
+                                                    <width>61</width>
+                                                    <height>20</height>
+                                                </size>
+                                            </property>
+                                        </spacer>
+                                    </hbox>
                                 </widget>
                                 <widget class="QLayoutWidget">
                                     <property name="name">
-                                        <cstring>layout125</cstring>
-                                    </property>
-                                    <vbox>
+                                        <cstring>layout123</cstring>
+                                    </property>
+                                    <hbox>
                                         <property name="name">
                                             <cstring>unnamed</cstring>
                                         </property>
-                                        <property name="margin">
-                                            <number>0</number>
-                                        </property>
-                                        <property name="spacing">
-                                            <number>0</number>
-                                        </property>
-                                        <widget class="QLayoutWidget">
-                                            <property name="name">
-                                                <cstring>layout32</cstring>
-                                            </property>
-                                            <hbox>
-                                                <property name="name">
-                                                    <cstring>unnamed</cstring>
-                                                </property>
-                                                <widget class="QLabel">
-                                                    <property name="name">
-                                                        <cstring>txTAPTerminate</cstring>
-                                                    </property>
-                                                    <property name="text">
-                                                        <string>&amp;Terminate Application</string>
-                                                    </property>
-                                                    <property name="buddy" stdset="0">
-                                                        <cstring>leTAPTerminate</cstring>
-                                                    </property>
-                                                </widget>
-                                                <spacer>
-                                                    <property name="name">
-                                                        <cstring>spacer15</cstring>
-                                                    </property>
-                                                    <property name="orientation">
-                                                        <enum>Horizontal</enum>
-                                                    </property>
-                                                    <property name="sizeType">
-                                                        <enum>Expanding</enum>
-                                                    </property>
-                                                    <property name="sizeHint">
-                                                        <size>
-                                                            <width>61</width>
-                                                            <height>20</height>
-                                                        </size>
-                                                    </property>
-                                                </spacer>
-                                            </hbox>
+                                        <widget class="QLineEdit">
+                                            <property name="name">
+                                                <cstring>leTAPTerminate</cstring>
+                                            </property>
+                                            <property name="frameShape">
+                                                <enum>LineEditPanel</enum>
+                                            </property>
+                                            <property name="frameShadow">
+                                                <enum>Sunken</enum>
+                                            </property>
+                                            <property name="whatsThis" stdset="0">
+                                                <string>Displays the command executed to terminate the TAP interface.</string>
+                                            </property>
                                         </widget>
-                                        <widget class="QLayoutWidget">
-                                            <property name="name">
-                                                <cstring>layout123</cstring>
-                                            </property>
-                                            <hbox>
-                                                <property name="name">
-                                                    <cstring>unnamed</cstring>
-                                                </property>
-                                                <widget class="QLineEdit">
-                                                    <property name="name">
-                                                        <cstring>leTAPTerminate</cstring>
-                                                    </property>
-                                                    <property name="frameShape">
-                                                        <enum>LineEditPanel</enum>
-                                                    </property>
-                                                    <property name="frameShadow">
-                                                        <enum>Sunken</enum>
-                                                    </property>
-                                                    <property name="whatsThis" stdset="0">
-                                                        <string>Displays the command executed to terminate the TAP interface.</string>
-                                                    </property>
-                                                </widget>
-                                                <widget class="QToolButton">
-                                                    <property name="name">
-                                                        <cstring>pbTAPTerminate</cstring>
-                                                    </property>
-                                                    <property name="text">
-                                                        <string>Select</string>
-                                                    </property>
-                                                    <property name="whatsThis" stdset="0">
-                                                        <string>Selects the terminate application.</string>
-                                                    </property>
-                                                </widget>
-                                            </hbox>
+                                        <widget class="QToolButton">
+                                            <property name="name">
+                                                <cstring>pbTAPTerminate</cstring>
+                                            </property>
+                                            <property name="text">
+                                                <string>Select</string>
+                                            </property>
+                                            <property name="whatsThis" stdset="0">
+                                                <string>Selects the terminate application.</string>
+                                            </property>
+                                            <property name="focusPolicy">
+                                                <enum>TabFocus</enum>
+                                            </property>
                                         </widget>
-                                    </vbox>
+                                    </hbox>
                                 </widget>
                             </vbox>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 2976)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 2979)
@@ -295,7 +295,4 @@
                 <number>3</number>
             </property>
-            <property name="whatsThis" stdset="0">
-                <string>Lists all available host interfaces.</string>
-            </property>
         </widget>
         <widget class="QLabel" row="0" column="1">
@@ -1976,4 +1973,7 @@
                         <property name="name">
                             <cstring>gbInterfaceList</cstring>
+                        </property>
+                        <property name="title">
+                            <string>Host &amp;Interfaces</string>
                         </property>
                         <vbox>