Index: trunk/src/VBox/Runtime/table/avl_Enum.cpp.h
===================================================================
--- trunk/src/VBox/Runtime/table/avl_Enum.cpp.h	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avl_Enum.cpp.h	(revision 2981)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlgcptr.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlgcptr.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlgcptr.cpp	(revision 2981)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTGCPTR, unique keys.
+ * innotek Portable Runtime - AVL tree, RTGCPTR, unique keys.
  */
 
Index: trunk/src/VBox/Runtime/table/avlhcphys.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlhcphys.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlhcphys.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTHCPHYS, unique keys.
+ * innotek Portable Runtime - AVL tree, RTHCPHYS, unique keys.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlogcphys.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlogcphys.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlogcphys.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTGCPHYS, unique keys, offset pointers.
+ * innotek Portable Runtime - AVL tree, RTGCPHYS, unique keys, offset pointers.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (c) 2006 InnoTek Systemberatung GmbH
+ * Copyright (c) 2006 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlogcptr.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlogcptr.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlogcptr.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTGCPTR, unique keys, offset pointers.
+ * innotek Portable Runtime - AVL tree, RTGCPTR, unique keys, offset pointers.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlohcphys.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlohcphys.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlohcphys.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTHCPHYS, unique keys, offset pointers.
+ * innotek Portable Runtime - AVL tree, RTHCPHYS, unique keys, offset pointers.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avloioport.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avloioport.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avloioport.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTIOPORT, unique keys, offset pointers.
+ * innotek Portable Runtime - AVL tree, RTIOPORT, unique keys, offset pointers.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlpv.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlpv.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlpv.cpp	(revision 2981)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, void *, unique keys.
+ * innotek Portable Runtime - AVL tree, void *, unique keys.
  */
 
Index: trunk/src/VBox/Runtime/table/avlrgcptr.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlrgcptr.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlrgcptr.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTGCPTR, range, unique keys.
+ * innotek Portable Runtime - AVL tree, RTGCPTR, range, unique keys.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlrogcphys.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlrogcphys.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlrogcphys.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTGCPHYS, range, unique keys, offset pointers.
+ * innotek Portable Runtime - AVL tree, RTGCPHYS, range, unique keys, offset pointers.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlrogcptr.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlrogcptr.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlrogcptr.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTGCPTR, range, unique keys, offset pointers.
+ * innotek Portable Runtime - AVL tree, RTGCPTR, range, unique keys, offset pointers.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlroioport.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlroioport.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlroioport.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTIOPORT, range, unique keys, offset pointers.
+ * innotek Portable Runtime - AVL tree, RTIOPORT, range, unique keys, offset pointers.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlroogcptr.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlroogcptr.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlroogcptr.cpp	(revision 2981)
@@ -1,10 +1,10 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTGCPTR, range, unique keys, overlapping ranges, offset pointers.
+ * innotek Portable Runtime - AVL tree, RTGCPTR, range, unique keys, overlapping ranges, offset pointers.
  */
 
 /*
  * Copyright (C) 2001-2004 knut st. osmundsen (bird-src-spam@anduin.net)
- * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ * Copyright (C) 2006-2007 innotek GmbH
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/table/avlu32.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlu32.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlu32.cpp	(revision 2981)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, uint32_t, unique keys.
+ * innotek Portable Runtime - AVL tree, uint32_t, unique keys.
  */
 
Index: trunk/src/VBox/Runtime/table/avlul.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/avlul.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/avlul.cpp	(revision 2981)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, unsigned long, unique keys.
+ * innotek Portable Runtime - AVL tree, unsigned long, unique keys.
  */
 
Index: trunk/src/VBox/Runtime/table/table.cpp
===================================================================
--- trunk/src/VBox/Runtime/table/table.cpp	(revision 2477)
+++ trunk/src/VBox/Runtime/table/table.cpp	(revision 2981)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * InnoTek Portable Runtime - AVL tree, RTHCPHYS, unique keys.
+ * innotek Portable Runtime - AVL tree, RTHCPHYS, unique keys.
  */
 